% REPLACE_OPTION - This is a preprocessing tool for the excellent
% process_options tool. I find myself passing on the arguments into
% subfunctions all the time, and would basically be able to remove or
% change elements of the cell-array coming into function. One example may
% be 'verbose' being ?n?at the first-called-function, then being set to
% 'off' when the parameters are called to subfunctions.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function fixedValues = replace_options(originalValues, changeValues, deleteValues)
if nargin < 3, deleteValues = {}; end
fixedValues = originalValues;
if length(fixedValues) == 1, fixedValues=fixedValues{1}; end



% Now process all arguments in changeValues
for i=1:2:length(changeValues)
    found = 0;
    for j=1:2:length(fixedValues)
        if strcmpi(fixedValues{j}, changeValues{i})
            fixedValues{j + 1} = changeValues{i + 1};
            found = 1;
            break;
        end
    end
    if ~found
        % did not find, so add
        fixedValues{end+1} = changeValues{i};
        fixedValues{end+1} = changeValues{i+1};
    end
end
% ... and in deleteValues
for i=1:length(deleteValues)
    for j=1:2:length(fixedValues)
        if strcmpi(fixedValues{j}, deleteValues{i})
            fixedValues(j + 1) = [];
            fixedValues(j) = [];
            break;
        end
    end
end



