function fix_path()
% Fix path: Make sure that all the toolbox directories are in the path...


fullname = mfilename('fullpath');
shortname = mfilename();
current_path = fullname(1:length(fullname)-length(shortname)-1);
my_path = path;
finders = strfind(my_path, current_path);
if isempty(finders)
	possible_to_add = genpath(current_path);
	finders = [0 strfind(possible_to_add, pathsep)];
	use_me = [];
	for i=2:length(finders)
		sub = possible_to_add(finders(i-1)+1:finders(i));
		if length(strfind(sub, 'BACKUP')) + length(strfind(sub, 'TAKE_OUT')) ...
                + length(strfind(sub, 'OBSOLETE')) ...
                + length(strfind(sub, '.svn')) + length(strfind(sub, 'debug'))  > 0
			% Dont take this over
			% disp(['Do not include:' sub]);
		else
			% Append this one
			use_me = [use_me sub]; %#ok<AGROW>
            % disp(['Yes to:' sub]);
		end
	end
	addpath(use_me, '-end');
end
% Mve back to the directory where this file is located
cd(current_path);
